<?php

class mtg_cs_templater
{
  function tpl_struct()
  {
    $TPL = <<<EOD
//THIS FILE IS GENERATED AUTOMATICALLY, DON'T TOUCH IT!
%includes%

namespace %namespace% {

%attributes%
public %type_name% %class% %parent% 
{
  %fields%

  public %new_method% const uint STATIC_CLASS_ID = %class_id%;

  public %virt_method% uint CLASS_ID() 
  {
    return %class_id%; 
  }

  %commented_in_pod_begin%
  public %class%()
  {
    reset();
  }
  %commented_in_pod_end%

  public %virt_method% void reset() 
  {
    %fields_reset%
  }

  %commented_in_non_cloneable_begin%
  public %virt_clone_method% void copy(IMetaStruct other)
  {
    copyFrom((%class%)other);
  }

  public void copyFrom(%class% other)
  {
    var ctx = Meta.PrepareForClone(ref other);
    ctx.factory = AutogenBundle.createById;

    ctx.reader.BeginContainer();
    reset();
    syncFields(ctx);
    ctx.reader.EndContainer();

    %copy_fields%
  }

  public %virt_clone_method% IMetaStruct clone()
  {
    %class% copy = new %class%();
    copy.copy(this);
    return copy;
  }
  %commented_in_non_cloneable_end%

  public %virt_method% void syncFields(MetaSyncContext ctx) 
  {
%bitfields_sync_context%

%sync_buffer%
  }
  
  public %virt_method% int getFieldsCount() 
  {
    return %fields_count%; 
  }
  
  public %virt_method% int getWritableFieldsCount() 
  {
    return %dirty_fields_count%; 
  }
  
  %ext_methods%
}

} //namespace %namespace%

EOD;
    return $TPL;
  }

  function tpl_enum()
  {
    $TPL = <<<EOD
//THIS FILE IS GENERATED AUTOMATICALLY, DON'T TOUCH IT! 

namespace %namespace% {

%attributes%
public enum %class% {
  %fields%
}

} //namespace %namespace%
 
EOD;
    return $TPL; 
  }

  function tpl_rpc()
  {
    $TPL = <<<EOD
//THIS FILE IS GENERATED AUTOMATICALLY, DON'T TOUCH IT!

namespace %namespace% {

public class %class% : IRpc
{
  public IRpcError error = null;
  public %req_class% req = new %req_class%();
  public %rsp_class% rsp = new %rsp_class%();

  public int getCode() 
  {
    return %code%;
  }

  public void setError(IRpcError error)
  {
    this.error = error;
  }

  public IRpcError getError()
  {
    return error;
  }

  public IMetaStruct getRequest()
  {
    return req as IMetaStruct;
  }

  public IMetaStruct getResponse()
  {
    return rsp as IMetaStruct;
  }
}

} //namespace %namespace%

EOD;
    return $TPL;
  }

  function tpl_bundle()
  {
    $TPL = <<<EOD
//THIS FILE IS GENERATED AUTOMATICALLY, DON'T TOUCH IT!
using System.Collections.Generic;
using metagen;

%units_src%

namespace %namespace% {

public class AutogenBundle {

  static public IRpc createRpc(int code) 
  {
    switch(code) 
    {
      %create_rpc_by_id%
      default: 
      {
        return null;
      }
    }
  }

  static public IMetaStruct createById(uint class_id) 
  {
    //NOTE: reflection based creation, not reliable?
    //var type = id2type(class_id);
    //if(type == null)
    //  return null;
    //return (IMetaStruct)System.Activator.CreateInstance(type);
    
    //NOTE: faster alternative
    switch(class_id)
    {
      %create_struct_by_crc28%
      default: 
      {
        return null;
      }
    }
  }

  static public System.Type id2type(uint class_id) 
  {
    switch(class_id) 
    {
      %id2type%
      default: 
      {
        return null;
      }
    }
  }
}

} // namespace %namespace%

EOD;
    
    return $TPL;
  }
}
